package entropia;

import java.util.*;

public class FermiDirac2{
	public static void main(String[] args) {
		FrequencyMap<String> map = new FrequencyMap<>();
		for(int i = 0; i < 1200000; i++){
			String s = withoutReturn(2, 4, true);
			map.add(s);
		}
		map.printAll();
	}

	/**
	 * Zwraca tablice k liczb wybraych losowo z tablicy od 1 do n liczb bez
	 * zwracania (powtórzeń)
	 * @param k int - liczba wybieranych liczb
	 * @param n int - największa liczba
	 * @param sorted boolean - określa czy wyjściowa tablica liczb będzie
	 * posortowana czy nie, <code>true</code> oznacza tablicę posortowaną, <code>false</code>
	 * oznacza tablicę nie sortowaną
	 * @return int[] - tablica wybranych liczb 
	 */
	public static String withoutReturn(int k, int n, boolean sorted) {
		int[] wynik = new int[k];
		if(k > n){
			System.out
					.println("pierwsza liczba nie moze byc wieksza od drugiej");
		}
		else{
			int[] liczby = new int[n];
			for(int j = 0; j < liczby.length; j++){
				liczby[j] = j + 1;
			}
			for(int i = 0; i < wynik.length; i++){
				int l = (int)Math.floor(Math.random() * n);
				wynik[i] = liczby[l];
				liczby[l] = liczby[n - 1];
				n--;
			}
			if(sorted){
				Arrays.sort(wynik);
			}
		}
		return Arrays.toString(wynik);
	}
}
